#include "dxStdAfx.h"
#include "Vector.hpp"
#include "Material.hpp"

std::istream& operator>>(std::istream& cin, Vector& v)
{
	cin >> v.x >> v.y >> v.z;
	return cin;
}

const Vector Vector::RGBBLACK(0.0f, 0.0f, 0.0f);
const Vector Vector::RGBWHITE(0.999f, 0.999f, 0.999f);
const Vector Vector::RGBRED(0.9f, 0.0f, 0.0f);
const Vector Vector::RGBGREEN(0.0f, 0.9f, 0.0f);
const Vector Vector::RGBBLUE(0.0f, 0.0f, 0.9f);
const Vector Vector::RGBLIGHTBLUE(0.5f, 0.5f, 0.9f);
const Vector Vector::RGBYELLOW(0.9f, 0.9f, 0.0f);
const Vector Vector::RGBORANGE(0.9f, 0.45f, 0.0f);

const Vector Vector::RGBLIGHTYELLOW(0.6f, 0.6f, 0.0f);
const Vector Vector::RGBDARKGRAY(0.5f, 0.5f, 0.5f);

const Material Material::DIFFUSEWHITE(Vector::RGBWHITE, Vector::RGBBLACK, 0.0f);
const Material Material::DIFFUSEGRAY(Vector::RGBDARKGRAY, Vector::RGBBLACK, 0.0f);
const Material Material::SHINYBLACK(Vector::RGBDARKGRAY, Vector::RGBDARKGRAY, 6.0f);
const Material Material::STEEL(Vector(0.8f, 0.8f, 0.8f), Vector(0.5f, 0.5f, 0.8f), 10.0f);

const Material Material::DIFFUSERED(Vector::RGBRED, Vector::RGBBLACK, 0.0f);
const Material Material::DIFFUSEBLUE(Vector::RGBBLUE, Vector::RGBBLACK, 0.0f);
const Material Material::DIFFUSELIGHTBLUE(Vector::RGBLIGHTBLUE, Vector::RGBBLACK, 0.0f);
const Material Material::DIFFUSEGREEN(Vector::RGBGREEN, Vector::RGBBLACK, 0.0f);
const Material Material::DIFFUSEYELLOW(Vector::RGBYELLOW, Vector::RGBBLACK, 0.0f);
const Material Material::DIFFUSEORANGE(Vector::RGBORANGE, Vector::RGBBLACK, 0.0f);

const Material Material::YELLOWPLASTIC(Vector::RGBLIGHTYELLOW, Vector::RGBDARKGRAY, 30.0f);

const Material Material::LAMP(Vector::RGBWHITE, Vector::RGBBLACK, 0.0f,
							  Vector::RGBWHITE, Vector::RGBBLACK, 0.0f);

const double Vector::PI = 3.14159265358979323846;