// DelaunayMesh.h: interface for the DelaunayMesh class.
//
//////////////////////////////////////////////////////////////////////

#pragma once
#include "Vector.hpp"
#include "Woctree.h"
#include "Woctreebranch.h"
#include "Wsimplex.h"
#include "WsubMesh.h"

class DelaunayMesh
{
public:
	::std::vector<Vector*> nodeArray;
    ::std::vector<Wsimplex*> simplexArray;
private:
	Woctree* tetrahedra;

	Vector encloseCentre;
	double encloseRadius;

	WsubMesh* cavvie;
	int crashed;

public:
	Wsimplex* search(Vector* pixie);
	int getSimplexCount();
	char add(Vector *,Wsimplex* starter=NULL);
	DelaunayMesh(Vector*, double);
	virtual ~DelaunayMesh();

};


