#pragma once

class Intersectable;

/*!
\brief Result record for a ray-casting operation.
*/
class HitRec {
public:
	//! Intersectable hit by the ray
	Intersectable*	object;	

	//! point of the intersection
	Vector	point;		
	//! normal at the intersection
	Vector  normal;
	//! texture coordinates at the intersection
	Vector	texUV;
	//! Material of the Intersectable that was hit
	const Material* material;
	//! distance from ray origin
	float	depth;

	//! valid flag
	bool	isIntersect;

	//! constructor
	HitRec() { 
		depth=0.0f;
	}
};