#pragma once
#include "Vector.hpp"
#include <ostream>

/*!
\brief Class that describes a virtual light source on a diffuse surface.
*/
class Radion
{
public:
	//! surface normal at the virtual light source
	Vector normal;
	//! power of the virtual light source
	Vector radiance;
	//! position of the virtual light source
	Vector position;

	//! probability of generation (useful for clipping the form factor)
	float probability;

	Radion(void);
	~Radion(void);
};

std::ostream& operator<<(std::ostream& s, const Radion& r);
std::istream& operator>>(std::istream& s, Radion& r);