float cutNearness2;// 100.0

struct vsInputBushToAtlas
{
    float4	pos			: POSITION;
    float2	tex			: TEXCOORD0;
    float3	normal		: NORMAL;
};


struct vsOutputBushToAtlas
{
    float4	pos			: POSITION;
    float2	tex			: TEXCOORD0;
    float4	worldPos	: TEXCOORD1;
    float3	normal		: TEXCOORD2; 
    float4 occProjPos	: TEXCOORD3;
};

vsOutputBushToAtlas
	vsRenderBushToAtlas(vsInputBushToAtlas input)
{
    vsOutputBushToAtlas output = (vsOutputBushToAtlas)0;
    
	output.pos.xy=float2(2,-2)*input.tex-float2(1,1);
	output.pos.y=-1*output.pos.y; //Texture space to screen space.
    output.pos.z=0;
    output.pos.w=1;
  
    output.worldPos = mul(input.pos, modelToWorldMatrix);
    output.normal = mul(input.normal, inverseTransposedModelToWorldMatrix);
	output.occProjPos = mul(output.worldPos, occWorldToProjMatrix);	    
    output.tex = input.tex;

    return output;
}

float4
	psRenderBushToAtlas(vsOutputBushToAtlas input) : COLOR0
{
	input.occProjPos /= input.occProjPos.w;
	float2 occTexPos = mul(input.occProjPos.xyw, occProjToTexMatrix);
	
	input.normal = normalize(input.normal);
	float3 diff = lightPos - input.worldPos.xyz;
	float4 retVal = float4(0, 0, 0, 1);
	float3 diffDir = normalize(diff);
	float cosa = dot(diffDir, input.normal);
	float cosb = -dot(diffDir, normalize(lightDir));
	float dist2 = dot(diff, diff);

	float visibility = tex2Dlod(depthMapSampler, float4(occTexPos, input.occProjPos.z, 0) );
	float formFactor;
	if( cosa > 0.0)
	{
		if( cosb < 0.01 && cosb > -0.1)
			cosb = 	0.01;
		float nearness = cosb * cosb * dist2;
		if( nearness < cutNearness2)
		{
			float e2 = dist2 * (1.0 - cosb * cosb);
			float dist2dash = e2 + cutNearness2;
			formFactor = cosa * sqrt(cutNearness2 / dist2dash ) / dist2dash;
		}
		else
			formFactor = cosa * cosb / dist2;
			
		if( cosb > 0.0)
		{
			retVal = float4(lightPower * formFactor * visibility, 1);
		}
	}
	return retVal;// + float4(0.3, 0, 0, 1);
}

technique BushToAtlas{
	pass P0
    {
        VertexShader = compile vs_3_0 vsRenderBushToAtlas();
        PixelShader  = compile ps_3_0 psRenderBushToAtlas();
    }
}
